<?php

namespace App\Services\Customer;

use CodeIgniter\HTTP\IncomingRequest;

use App\Entities\Customer\ClientEntity;
use App\Models\Customer\ClientModel;

class ClientService extends CustomerService
{

    protected ?IncomingRequest $request = null;
    public function __construct(?IncomingRequest $request = null)
    {
        parent::__construct($request);
        $this->addClassName('Client');
    }
    public function getModelClass(): ClientModel
    {
        return new ClientModel();
    }
    public function getEntityClass(): ClientEntity
    {
        return new ClientEntity();
    }
    public function getFields(): array
    {
        return ['name', 'email', 'phone', 'role'];
    }
    public function getFilterFields(): array
    {
        return ['role', 'status'];
    }
    public function getBatchJobFields(): array
    {
        return ['status'];
    }
    public function create(array $formDatas, mixed $entity = new ClientEntity()): ClientEntity
    {
        $formDatas['role'] = implode(DEFAULTS["DELIMITER_ROLE"], $formDatas['role']);
        return parent::create($formDatas, $entity ?? new ClientEntity());
    }
    public function modify(mixed $entity, array $formDatas): ClientEntity
    {
        // die(var_export($formDatas, true));
        //Role을 지정이 있을경우에만 , toggle이나 batcjhjob에서는 없을수도 있으므로
        if (isset($formDatas['role'])) {
            $formDatas['role'] = implode(DEFAULTS["DELIMITER_ROLE"], $formDatas['role']);
        }
        // die(var_export($formDatas, true));
        return parent::modify($entity, $formDatas);
    }
}
